#pragma once
namespace blpjpeg {
    typedef unsigned char BYTE;
    typedef wchar_t WORD;
    typedef unsigned long DWORD;
    typedef unsigned long long int QWORD;
    typedef struct jpegDecompress
    {
        DWORD data;
        BYTE databits;
        BYTE huffCounts[8][16];
        BYTE huffVals[8][256];
        short* dehuff;
        float outptr[4][64];

        int DCLast[4];
        float quantVals[4][64];

        BYTE *source;
        DWORD length;
        BYTE* bitmap;

        BYTE metod;
        DWORD height;
        DWORD width;

        BYTE curComponent;
        BYTE SOSComponents[4];

        BYTE hSampling[4];
        BYTE wSampling[4];
        BYTE maxhSampl;
        BYTE maxwSampl;

        DWORD components;
        BYTE componentID[4];

        BYTE AChuffId[4];
        BYTE DChuffId[4];
        BYTE quantID[4];
        BYTE precision;
        BYTE SOSSs;
        BYTE SOSSe;
        BYTE SOSAl;//shift
        WORD SOSAh;//mask
        DWORD eobrun;
        int (*callback)(int);
        BYTE dctlimittable[1024];
    }jpegDecompress;

    typedef struct jpegCompress {
        float quantVals[64];
        DWORD quality;//1-100
        BYTE* outbuff;
        short* workbuff;
        BYTE* inbuff;
        DWORD height;
        DWORD width;
        DWORD outlenght;

        BYTE huffCounts[2][16];
        BYTE huffVals[2][256];
        WORD huffCodes[2][256];
        int huffSize[2][257];


    }jpegCompress;

    void blpjpegDecompress(jpegDecompress* pjpegDecompress);
    void blpjpegCompress(jpegCompress* pjpegCompress);
}


